DEFINT A-Z
$CODE SEG "Xgraf V1.00"

'draws a horizontal line
'down% = how many points down
SUB HLINE(BYVAL x% , BYVAL y% , BYVAL down% , BYVAL col?) PUBLIC
  FOR i% = 0 TO down% - 1
    XPSET x% , y% + i% , col?
  NEXT
END SUB

'fills a part of the screen (FILL 0 , 0 , 64000 , 0 = CLRSCR)
SUB FILL(BYVAL x% , BYVAL y% , BYVAL bytes?? , BYVAL col?) PUBLIC
  ! MOV CX , bytes??
  ! MOV AX , 320
  ! MUL y%
  ! MOV DI , AX           ; Formel : 320 * y + x
  ! ADD DI , x%           ; fr Offset
  ! MOV DX , &hA000       ; Segment : A000h (Videospeicher)
  ! MOV ES , DX
  ! MOV AL , col?         ; Farbe
  ! REP STOSB
END SUB

'draws a box, if fillit = %TRUE the box will be filled
SUB BOX(BYVAL x1 ,BYVAL y1 ,BYVAL x2 ,BYVAL y2 ,BYVAL col , fillit) PUBLIC
  IF ISFALSE fillit THEN
    FILL  x1 , y1 , x2 - x1 , col
    FILL  x1 , y2 , x2 - x1 , col
    HLINE x1 , y1 , y2 - y1 + 1 , col
    HLINE x2 , y1 , y2 - y1 + 1 , col
  ELSE
    FOR y = y1 TO y2
      FILL x1 , y , x2 - x1 , col
    NEXT
  END IF
END SUB

'draws a kind of window, not the best, but I needed it
SUB WIN(BYVAL x1 ,BYVAL y1 ,BYVAL x2 ,BYVAL y2 ,BYVAL col1 ,BYVAL col2) PUBLIC
  BOX x1 , y1 , x2 , y2 , col2 , 1
  BOX x1 , y1 , x2 , y2 , col1 , 0
  BOX x1 + 1 , y1 + 1 , x2 - 1 , y2 -1 , col1 , 0
  FILL x1 , y1 + 12 , x2 - x1 , col1
  HLINE x1 + 12 , y1 , 12 , col1
END SUB
