'for Pascal : Mike Mller
'for PowerBASIC : Robert Seidel 06.02.95 , 04.03.95

DEFINT A-Z
$CODE SEG "XGraf V1.00"
%demo = 0 '-> Error, if Xgraf is not liked !!!

DIM FONTSEG AS SHARED WORD
DIM FONTPTR AS SHARED WORD
DIM CURX    AS SHARED INTEGER
DIM CURY    AS SHARED INTEGER

DIM	TABLE(0 TO 7) AS SHARED BYTE
FOR i = 0 TO 7
  READ TABLE(i)
NEXT
DATA 128, 64, 32, 16, 8, 4, 2, 1

'its necessary to use the BIOS-font, if you have 8x8
'fonts you can use this by setting FONTSEG/FONTPTR
SUB INICHAR PUBLIC

	!	PUSH    BP
	!	MOV     AX,&h1130
	!	MOV     BH,3
	!	INT     &h10
	!	MOV     AX,BP
	!	POP     BP
	!	MOV     FONTPTR,AX
	!	MOV     FONTSEG,ES

END SUB

'prints a text at CURX,CURY (vars that are shared) in a
'special color, with special space between the char
'(DistanceX , DistanceY) ; if Background is 0 then the
'background will be not destroyed

SUB XPRINT(Text$ ,BYVAL Col,BYVAL DistanceX ,_
           BYVAL DistanceY ,BYVAL Background) PUBLIC

DIM I    AS STATIC BYTE
DIM J    AS STATIC BYTE
DIM CODE AS STATIC BYTE
DIM X    AS STATIC WORD

DEF SEG = FONTSEG

FOR X = 1 TO LEN(Text$)

  FOR I = 0 TO 7

     CODE = PEEKI(FONTPTR + 8 * ASC(MID$(Text$ , X , 1)) + I)

      FOR J=0 TO 7
      	IF (CODE AND TABLE(J)) <> 0 THEN
          XPSET CURX + J ,CURY + I , COL
	      ELSE
          IF Background > 0 THEN
            XPSET CURX + J ,CURY + I , Background
          END IF
        END IF
      NEXT

  NEXT

  INCR CURX , DistanceX
  IF CURX => 320 THEN
    CURX = 0
    INCR CURY , DistanceY
  END IF

NEXT

END SUB

'prints a text at CURX,CURY (vars that are shared) in a
'special color, with special space between the char
'(DistanceX , DistanceY) ; if Background is 0 then the
'background will be not destroyed
'! every line of the char gets the next color-number (TEST IT)

SUB XPRINTC(Text$ ,BYVAL Col,BYVAL DistanceX ,_
           BYVAL DistanceY ,BYVAL Background) PUBLIC

DIM I    AS STATIC BYTE
DIM J    AS STATIC BYTE
DIM CODE AS STATIC BYTE
DIM X    AS STATIC WORD

DEF SEG = FONTSEG

FOR X = 1 TO LEN(Text$)

  FOR I = 0 TO 7

     CODE = PEEKI(FONTPTR + 8 * ASC(MID$(Text$ , X , 1)) + I)

      FOR J = 0 TO 7
      	IF (CODE AND TABLE(J)) <> 0 THEN
          XPSET CURX + J ,CURY + I , COL + I
	      ELSE
          IF Background > 0 THEN
            XPSET CURX + J ,CURY + I , Background
          END IF
        END IF
      NEXT

  NEXT

  INCR CURX , DistanceX
  IF CURX => 320 THEN
    CURX = 0
    INCR CURY , DistanceY
  END IF

NEXT

END SUB

'Xprint with position
SUB XPRINTXY(BYVAL x , BYVAL y , Text$ ,BYVAL Col,BYVAL DistanceX ,_
             BYVAL DistanceY ,BYVAL Background) PUBLIC

CURX = x
CURY = y
DIM I    AS STATIC BYTE
DIM J    AS STATIC BYTE
DIM CODE AS STATIC BYTE

DEF SEG = FONTSEG

FOR X = 1 TO LEN(Text$)

  FOR I = 0 TO 7

     CODE = PEEKI(FONTPTR + 8 * ASC(MID$(Text$ , X , 1)) + I)

      FOR J=0 TO 7
      	IF (CODE AND TABLE(J)) <> 0 THEN
          XPSET CURX + J ,CURY + I , COL
	      ELSE
          IF Background > 0 THEN
            XPSET CURX + J ,CURY + I , Background
          END IF
        END IF
      NEXT

  NEXT

  INCR CURX , DistanceX
  IF CURX => 320 THEN
    CURX = 0
    INCR CURY , DistanceY
  END IF

NEXT

END SUB



$IF %demo
  $INCLUDE "xgraf3"
  XSCREEN &h13
  IniChar
  FOR i = 1 TO 25
  XPRINT "HELLO WORLD !", i , 8 , 8 , 0
  NEXT
$ENDIF